// import React, { Component } from "react";
// import PropTypes from "prop-types";
// import { Dropdown, Button, Menu, Table, Row, Upload, Divider } from "antd";
// import {
//   DownOutlined,
//   EditOutlined,
//   DeleteOutlined,
//   PlusOutlined,
//   UploadOutlined,
//   SaveOutlined,
// } from "@ant-design/icons";
// import TableCell from "../tableCell";
// import * as Util from "../../helpers/util";
// import { getTranslation } from "../../labels";
// import TableHeader from "../tableHeader";
// import {
//   setCurrentObjectPath,
//   sendNewCollectionElement,
//   sendRefreshRequest,
//   setObject,
//   cancelCollectionElement,
//   requestCheckIntegrity,
//   setCurrentKeyFocus,
//   uploadFile,
//   sendRequest,
// } from "../../redux/actions";
// import Key from "../key/index";

// export class CompositionGroup extends Component {
//   static getDerivedStateFromProps(nextProps) {
//     const { vs, tdlPath, path } = nextProps;
//     const group = vs.getTdlWithPath(tdlPath);
//     const object = Util.cloneDeep(vs.getObject(path, ""));
//     const { usecaseId } = vs;
//     const { actions, keys } = group;

//     const hasCollectionView = !!actions.find(
//       ({ actionName, isAvailable }) => actionName === "collectionView" && isAvailable === "true",
//     );
//     const hasCollectionNew = !!actions.find(
//       ({ actionName, isAvailable }) => actionName === "newCollectionElement" && isAvailable === "true",
//     );
//     const hasCollectionEdit = !!actions.find(
//       ({ actionName, isAvailable }) => actionName === "collectionEdit" && isAvailable === "true",
//     );
//     const hasCollectionDelete = !!actions.find(
//       ({ actionName, isAvailable }) => actionName === "collectionDelete" && isAvailable === "true",
//     );
//     const containsFile = !!keys.find((key) => Util.isFileType(key.type));

//     return {
//       usecaseId,
//       object,
//       group,
//       hasCollectionView,
//       hasCollectionNew,
//       hasCollectionEdit,
//       hasCollectionDelete,
//       containsFile,
//       tdlPath,
//       path,
//     };
//   }

//   constructor(props) {
//     super(props);
//     this.state = {
//       usecaseId: null,
//       object: [],
//       group: {},
//       hasCollectionView: false,
//       hasCollectionNew: false,
//       hasCollectionEdit: false,
//       hasCollectionDelete: false,
//       containsFile: false,
//       currentObject: {
//         index: null,
//         lastObjectValue: {},
//       },
//     };
//   }

//   shouldComponentUpdate(nextProps, nextState) {
//     return !Util.isEqual(nextState, this.state);
//   }

//   getFixedPath() {
//     const { path } = this.state;
//     return path.substr(0, path.lastIndexOf("*") - 1);
//   }

//   getKeyPath(keyMeta) {
//     const { currentObject } = this.state;
//     return `${this.getFixedPath()}[${currentObject.index}].${keyMeta.keyName}`;
//   }

//   addNewObject() {
//     const { dispatch } = this.props;
//     const { usecaseId, object } = this.state;
//     const currentPath = this.getFixedPath();
//     dispatch(setCurrentObjectPath(usecaseId, currentPath));
//     dispatch(
//       sendNewCollectionElement(usecaseId, (response) => {
//         if (Util.isSuccessResponse(response)) {
//           const currentIndex = object.length > 0 ? object.length : 0;
//           this.setState({
//             currentObject: { index: currentIndex },
//           });
//           dispatch(setCurrentObjectPath(usecaseId, `${currentPath}[${currentIndex}]`));
//         }
//       }),
//     );
//   }

//   saveHandler() {
//     const { dispatch } = this.props;
//     const { usecaseId } = this.state;
//     dispatch(
//       requestCheckIntegrity(usecaseId, (response) => {
//         if (Util.isSuccessResponse(response)) {
//           this.setState({ currentObject: {} });
//         }
//       }),
//     );
//   }

//   editHandler(index) {
//     const { object } = this.state;
//     this.setState({
//       currentObject: {
//         index,
//         lastObjectValue: Util.cloneDeep(object[index]),
//       },
//     });
//   }

//   cancelHandler() {
//     const { dispatch } = this.props;
//     const { usecaseId, currentObject } = this.state;
//     const { lastObjectValue } = currentObject;
//     if (lastObjectValue && !Util.isEmpty(lastObjectValue)) {
//       dispatch(setObject(usecaseId, `${this.getFixedPath()}[${currentObject.index}]`, lastObjectValue));
//       this.setState({ currentObject: {} });
//     } else {
//       dispatch(
//         cancelCollectionElement(usecaseId, (response) => {
//           if (Util.isSuccessResponse(response)) {
//             this.setState({ currentObject: {} });
//           }
//         }),
//       );
//     }
//   }

//   deleteHandler(index) {
//     const { dispatch } = this.props;
//     const { object, usecaseId } = this.state;
//     const newObject = Util.cloneDeep(object);
//     newObject.splice(index, 1);
//     dispatch(setObject(usecaseId, this.getFixedPath(), newObject));
//     dispatch(sendRefreshRequest(usecaseId));
//   }

//   downloadHandler(index) {
//     // const { dispatch } = this.props;
//     // const { usecaseId } = this.state;
//     // const currentPath = this.getFixedPath();
//     // dispatch(setCurrentObjectPath(usecaseId, `${currentPath}[${currentIndex}]`));

//   }

//   uploadHandler(file) {
//     const { dispatch } = this.props;
//     const { usecaseId } = this.state;
//     dispatch(
//       sendRefreshRequest(usecaseId, true, (response) => {
//         if (Util.isSuccessResponse(response)) {
//           dispatch(setCurrentKeyFocus(usecaseId, this.getFixedPath()));
//           dispatch(uploadFile(usecaseId, file, this.getFixedPath()));
//         }
//       }),
//     );
//   }

//   render() {
//     const { vs, dispatch, timeZoneOffset } = this.props;
//     const {
//       object,
//       group,
//       hasCollectionEdit,
//       hasCollectionDelete,
//       hasCollectionNew,
//       containsFile,
//       usecaseId,
//       currentObject,
//       tdlPath,
//     } = this.state;
//     const { keys, pk } = group;

//     const columns = [
//       {
//         title: "#",
//         fixed: "left",
//         render: (text, record, index) => index + 1,
//         width: 10,
//       },
//     ];

//     if (hasCollectionEdit || hasCollectionDelete || containsFile) {
//       columns.push({
//         title: "",
//         fixed: "left",
//         width: 10,
//         render: (text, record, index) => (
//           <Dropdown
//             trigger={["hover"]}
//             overlay={
//               <Menu>
//                 {hasCollectionEdit && (
//                   <Menu.Item
//                     key={`${usecaseId}_composition_${pk}_edit`}
//                     icon={<EditOutlined />}
//                     onClick={() => {
//                       this.editHandler(index);
//                     }}
//                   >
//                     {getTranslation("edit")}
//                   </Menu.Item>
//                 )}
//                 {containsFile && (
//                   <Menu.Item
//                     key={`${usecaseId}_composition_${pk}_download`}
//                     icon={<DownOutlined />}
//                     onClick={() => {
//                       this.downloadHandler(index);
//                     }}
//                   >
//                     {getTranslation("download")}
//                   </Menu.Item>
//                 )}
//                 {hasCollectionDelete && (
//                   <Menu.Item
//                     key={`${usecaseId}_composition_${pk}_delete`}
//                     icon={<DeleteOutlined />}
//                     onClick={() => {
//                       this.deleteHandler(index);
//                     }}
//                   >
//                     {getTranslation("delete")}
//                   </Menu.Item>
//                 )}
//               </Menu>
//             }
//           >
//             <Button shape="circle" size="small" icon={<DownOutlined />} />
//           </Dropdown>
//         ),
//       });
//     }

//     keys.map((key) => {
//       columns.push({
//         title: <TableHeader label={key.label} />,
//         render: (obj) => <TableCell object={obj} meta={key} />,
//       });
//     });

//     return (
//       <>
//         <Table
//           columns={columns}
//           dataSource={object}
//           locale={{ emptyText: getTranslation("tableEmptyText") }}
//           pagination={false}
//           bordered
//           scroll={object && object.length > 0 ? { scrollToFirstRowOnChange: true, x: "max-content" } : {}}
//           size="small"
//           rowKey={(record) => record.pk}
//           title={() => {
//             return (
//               hasCollectionNew && (
//                 <Row align="middle" justify="start">
//                   <Button
//                     icon={<PlusOutlined />}
//                     onClick={() => {
//                       this.addNewObject();
//                     }}
//                   >
//                     {getTranslation("add")}
//                   </Button>
//                 </Row>
//               )
//             );
//           }}
//         />
//         {currentObject && currentObject.index !== null && currentObject.index !== undefined && (
//           <>
//             <Row gutter={[8, 8]}>
//               {group.keys.map((key, index) => (
//                 <Key
//                   vs={vs}
//                   path={this.getKeyPath(key)}
//                   tdlPath={`${tdlPath}.keys-${index}`}
//                   dispatch={dispatch}
//                   timeZoneOffset={timeZoneOffset}
//                   isSearch={false}
//                 />
//               ))}
//             </Row>
//             <Divider />
//             <Row gutter={[8, 8]}>
//               <Button
//                 icon={<SaveOutlined />}
//                 onClick={() => {
//                   this.saveHandler();
//                 }}
//               >
//                 {getTranslation("save")}
//               </Button>
//               <Button
//                 icon={<SaveOutlined />}
//                 onClick={() => {
//                   this.cancelHandler();
//                 }}
//               >
//                 {getTranslation("cancel")}
//               </Button>
//             </Row>
//           </>
//         )}
//       </>
//     );
//   }
// }

// CompositionGroup.propTypes = {
//   tdlPath: PropTypes.string.isRequired,
//   vs: PropTypes.objectOf(PropTypes.any).isRequired,
//   path: PropTypes.string.isRequired,
//   dispatch: PropTypes.func.isRequired,
//   timeZoneOffset: PropTypes.number.isRequired,
// };
// export default CompositionGroup;
