import React from "react";
import PropTypes from "prop-types";
import { Card } from "@ant-design/react-native";
import * as Util from "@muhammadz/elixir-react-stateful/helpers/util";
import Simple from "./simple";
import Composition from "./composition";
import { Dimensions, View } from "react-native";

const Group = ({
  vs,
  tdlPath,
  path,
  isSearch,
  dispatch,
  timeZoneOffset,
  smallView,
  isRTL,
  isSMSRow,
  smsRowColor,
  theme,
  customStyle,
  isLoading,
  smsAdvance,
  pageNumber
}) => {
  const group = vs.getTdlWithPath(tdlPath);
  const isSimple = Util.isSimpleGroup(group);
  const CurrentGroupComponent = isSimple ? Composition : Simple;
  const groupLabel = tdlPath === "groups-0" ? null : group.label;
  let smsStyle = { backgroundColor: smsRowColor };
  console.log("hhhjjjkkkfff", smsAdvance)
  if (smsAdvance == false) {
    smsStyle = { backgroundColor: smsRowColor, height: 150, overflowY: "hidden" }
  }

  return (
    // <Card style={{backgroundColor:  smsRowColor}} bodyStyle={{flexDirection: "column"}}>
    //   {(!isSMSRow && groupLabel &&
    //     <Card.Header
    //       title={groupLabel}
    //     />) || <></>}
    //   <Card.Body >
    //     <CurrentGroupComponent
    //       key={group.id}
    //       vs={vs}
    //       path={`${path}${path && group.masterKey ? "." : ""}${group.masterKey}`}
    //       tdlPath={tdlPath}
    //       isSearch={isSearch}
    //       dispatch={dispatch}
    //       timeZoneOffset={timeZoneOffset}
    //       smallView={smallView}
    //       isRTL={isRTL}
    //       isSMSRow={isSMSRow}
    //       theme={theme}
    //       customStyle={customStyle}
    //       isLoading={isLoading}
    //       smsAdvance={smsAdvance}
    //     />
    //   </Card.Body>
    // </Card>
    // <View style={{border:"2px solid #333", display:"flex", flexDirection: "column", padding:10 ,width:"100%" }}>
    <CurrentGroupComponent
      key={group.id}
      vs={vs}
      path={`${path}${path && group.masterKey ? "." : ""}${group.masterKey}`}
      tdlPath={tdlPath}
      isSearch={isSearch}
      dispatch={dispatch}
      timeZoneOffset={timeZoneOffset}
      smallView={smallView}
      isRTL={isRTL}
      isSMSRow={isSMSRow}
      theme={theme}
      customStyle={customStyle}
      isLoading={isLoading}
      smsAdvance={smsAdvance}
      pageNumber={pageNumber}
    />
    // </View>

  );
};

Group.propTypes = {
  vs: PropTypes.objectOf(PropTypes.any).isRequired,
  tdlPath: PropTypes.string.isRequired,
  isSearch: PropTypes.bool,
  path: PropTypes.string,
  dispatch: PropTypes.func.isRequired,
  timeZoneOffset: PropTypes.number.isRequired,
  smallView: PropTypes.bool,
  isRTL: PropTypes.bool.isRequired,
  isSMSRow: PropTypes.bool,
  smsRowColor: PropTypes.string,
  theme: PropTypes.any.isRequired,
  customStyle: PropTypes.objectOf(PropTypes.any)
};

Group.defaultProps = {
  path: null,
  isSearch: false,
  smallView: false,
  isSMSRow: false,
  smsRowColor: "white",
};

export default Group;
