import React from "react";
import PropTypes from "prop-types";
import { KeyboardAwareScrollView } from "react-native-keyboard-aware-scrollview";
import { ScrollView, View } from "react-native";
import EKey from "../key/key";
import GenericGroup from "./index";
import { SMS_Keys } from "./../../config/options"
import { deviceHeight } from "../../helpers/util";
import { getTheme } from "../../styles/themes";
import GroupSlice from "../tdl/GroupsSlice";
// import {SMS_KEYS_COUNT} from '@env'


const extractPropsFromVs = ({ vs, tdlPath, path, isSearch }) => {
  const { usecaseId } = vs;
  const group = vs.getTdlWithPath(tdlPath);
  const object = isSearch ? vs.getSearchCriteriaObject() : vs.getObject(path, "");
  return {
    usecaseId,
    object,
    group,
  };
};

const SimpleGroup = ({ isSearch, tdlPath, path, vs, dispatch, timeZoneOffset, smallView, isRTL, isSMSRow, theme, customStyle, isLoading, smsAdvance,
  pageNumber }) => {
  const { group } = extractPropsFromVs({ vs, tdlPath, path, isSearch });
  // const theme = getTheme(themeName);
  // console.log("hidden keyssssssssssss", group)
  // if(group && group.subGroups)
  console.log("hidden keyssssssssssss", group)
  console.log("hidden keyssssssssssss pageNumber", pageNumber)
  // const keysToShow = isSMSRow ? SMS_Keys : group.keys.length
  const ContainerComponent = isSMSRow ? View : View;

  return (
    <>
      {group && group.keys && (pageNumber ==0 || pageNumber == undefined) &&
        <ContainerComponent style={theme.groupsContainerComponent}>
          {group.keys &&
            group.keys.slice(0, group.keys.length).map((key, index) => (
              //TODO check if key is inside isHidden

              <EKey
                key={`${key.pk}_Key`}
                path={`${path}${path ? "." : ""}${key.keyName}`}
                tdlPath={`${tdlPath}.keys.${index}`}
                isSearch={isSearch}
                vs={vs}
                dispatch={dispatch}
                timeZoneOffset={timeZoneOffset}
                smallView={smallView}
                isRTL={isRTL}
                theme={theme}
                customStyle={{ backgroundColor: "transparent" }}
                meta={vs.getTdlWithPath(`${tdlPath}.keys.${index}`)}
                isLoading={isLoading}
                smsAdvance={smsAdvance}
              />

            ))}
          {/* {!isSMSRow && group && group.subGroups &&
            group.subGroups.map(({ id }, index) => (
              <GenericGroup
                key={id}
                path={path}
                tdlPath={`${tdlPath}.subGroups.${index}`}
                vs={vs}
                isSearch={isSearch}
                dispatch={dispatch}
                timeZoneOffset={timeZoneOffset}
                isRTL={isRTL}
                theme={theme}
                customStyle={customStyle}
                isLoading={isLoading}

              />
            ))} */}
        </ContainerComponent>
      }
      {group && group.subGroups && group.subGroups[0] && group.subGroups[0].subGroups &&
        <GroupSlice
          isSearch={isSearch}
          tdlPath={tdlPath}
          path={path}
          vs={vs}
          dispatch={dispatch}
          timeZoneOffset={timeZoneOffset}
          smallView={smallView}
          isRTL={isRTL}
          isSMSRow={isSMSRow}
          theme={theme}
          customStyle={customStyle}
          isLoading={isLoading}
          smsAdvance={smsAdvance}
          ContainerComponent={ContainerComponent}
          groups={group.subGroups}
          pageNumber={pageNumber}

        />
      }
    </>
  );
};

SimpleGroup.propTypes = {
  vs: PropTypes.objectOf(PropTypes.any).isRequired,
  tdlPath: PropTypes.string.isRequired,
  path: PropTypes.string.isRequired,
  isSearch: PropTypes.bool,
  dispatch: PropTypes.func.isRequired,
  timeZoneOffset: PropTypes.number.isRequired,
  smallView: PropTypes.bool,
  isRTL: PropTypes.bool.isRequired,
  isSMSRow: PropTypes.bool,
  theme: PropTypes.objectOf(PropTypes.any).isRequired,
  customStyle: PropTypes.objectOf(PropTypes.any)
};

SimpleGroup.defaultProps = {
  isSearch: false,
  smallView: false,
  isSMSRow: false,
  customStyle: {}
};

// export default React.memo(SimpleGroup, (prevProps, nextProps) => {
//   if (!nextProps.path) {
//     return false;
//   }
//   console.time("compare Group");
//   const result = Util.isEqual(extractPropsFromVs(prevProps), extractPropsFromVs(nextProps));
//   console.timeEnd("compare Group");
//   return result;
// });

export default SimpleGroup;
