// import React, { useState, useEffect } from "react";
// import PropTypes from "prop-types";
// import { connect } from "react-redux";
// import { Layout, AutoComplete, Row, Col, Avatar, Button, Badge, Dropdown, Menu } from "antd";
// import {
//   UserOutlined,
//   SearchOutlined,
//   HomeOutlined,
//   BellOutlined,
//   MessageOutlined,
//   NotificationOutlined,
//   StarOutlined,
//   LogoutOutlined,
// } from "@ant-design/icons";
// import Time from "./time";
// import { sendRequest, changeActiveTab, Logout } from "../redux/actions";
// import { getTranslation } from "../labels";

// const { Header: AntHeader } = Layout;

// const Header = ({ dispatch, currentUser, timeZoneOffset, mainMenu, favorite }) => {
//   const [searchValue, setSearchValue] = useState("");
//   const [results, setResults] = useState([]);
//   const [favoriteModel, setFavoriteModel] = useState(null);

//   useEffect(() => {
//     setFavoriteModel(
//       <Menu>
//         {favorite.map((item) => (
//           <Menu.Item
//             key={`${favorite.label}${item.newTdlId}`}
//             onClick={() => {
//               dispatch(sendRequest({ tdlId: item.newTdlId }));
//             }}
//             icon={<StarOutlined />}
//           >
//             {item.label}
//           </Menu.Item>
//         ))}
//       </Menu>,
//     );
//   }, [favorite]);

//   const onSearch = (query) => {
//     const newResults = [];
//     setSearchValue(query);
//     mainMenu.map((modelObject) => {
//       modelObject.items.map((processObject) => {
//         processObject.items.map(({ label, tdlId }) => {
//           if (label.toLocaleLowerCase().includes(query.toLocaleLowerCase())) {
//             const categoryLabel = `${modelObject.label} / ${processObject.label}`;
//             let categoryIndex = newResults.findIndex((item) => item.label === categoryLabel);
//             if (!newResults[categoryIndex]) {
//               newResults.push({
//                 label: categoryLabel,
//                 options: [],
//               });
//               categoryIndex = newResults.length - 1;
//             }
//             newResults[categoryIndex].options.push({
//               value: tdlId,
//               label,
//             });
//           }
//         });
//       });
//     });
//     setResults(newResults);
//   };

//   const onSelect = (tdlId) => {
//     dispatch(sendRequest({ tdlId }));
//     setSearchValue("");
//     onSearch("");
//   };

//   return (
//     <AntHeader className="site-layout-background" style={{ padding: 0 }}>
//       <Row justify="center" align="center">
//         <Col span={6}>
//           <Row justify="space-around" align="middle">
//             <Col span={5}>
//               <Button
//                 type="link"
//                 title={getTranslation("home")}
//                 icon={<HomeOutlined className="headerIcon" />}
//                 onClick={() => {
//                   dispatch(changeActiveTab("home"));
//                 }}
//               />
//             </Col>
//             <Col span={5}>
//               <Badge>
//                 <Button
//                   type="link"
//                   title={getTranslation("alerts")}
//                   icon={<BellOutlined className="headerIcon" />}
//                   onClick={() => {
//                     dispatch(sendRequest({ tdlId: "CMS$$CMS$$-$$dynamicTaskMgmt" }));
//                   }}
//                 />
//               </Badge>
//             </Col>
//             <Col span={5}>
//               <Badge>
//                 <Button
//                   type="link"
//                   title={getTranslation("notifications")}
//                   icon={<NotificationOutlined className="headerIcon" />}
//                   onClick={() => {
//                     dispatch(sendRequest({ tdlId: "CMS$$CMS$$-$$notifications" }));
//                   }}
//                 />
//               </Badge>
//             </Col>
//             <Col span={5}>
//               <Badge>
//                 <Button
//                   type="link"
//                   title={getTranslation("messages")}
//                   icon={<MessageOutlined className="headerIcon" />}
//                   onClick={() => {
//                     dispatch(sendRequest({ tdlId: "CMS$$CMS$$-$$inbox" }));
//                   }}
//                 />
//               </Badge>
//             </Col>
//             <Col span={4}>
//               <Dropdown overlay={favoriteModel} placement="bottomCenter">
//                 <Button
//                   type="link"
//                   title={getTranslation("favorite")}
//                   icon={<StarOutlined className="headerIcon" />}
//                 />
//               </Dropdown>
//             </Col>
//           </Row>
//         </Col>
//         <Col span={7}>
//           <AutoComplete
//             placeholder={getTranslation("searchPlaceholder")}
//             prefix={<SearchOutlined />}
//             value={searchValue}
//             style={{ width: "100%" }}
//             options={results}
//             onSearch={onSearch}
//             onSelect={onSelect}
//             onKeyDown={(e) => {
//               if (e.keyCode === 40) {
//                 onSearch(searchValue);
//               }
//             }}
//           />
//         </Col>
//         <Col span={10}>
//           <Row justify="end" align="middle">
//             <Col span={6} />
//             <Col span={12}>
//               <Time timeZoneOffset={timeZoneOffset} />
//             </Col>
//             <Col span={6}>
//               <Dropdown
//                 trigger={["hover"]}
//                 overlay={
//                   <Menu>
//                     <Menu.Item
//                       icon={<LogoutOutlined />}
//                       onClick={() => {
//                         dispatch(Logout());
//                       }}
//                     >
//                       {getTranslation("logout")}
//                     </Menu.Item>
//                   </Menu>
//                 }
//               >
//                 <Row>
//                   <Col span={6}>
//                     <Avatar icon={<UserOutlined />} />
//                   </Col>
//                   <Col className="headerIcon" span={18}>
//                     {currentUser.username}
//                   </Col>
//                 </Row>
//               </Dropdown>
//             </Col>
//           </Row>
//         </Col>
//       </Row>
//     </AntHeader>
//   );
// };

// Header.propTypes = {
//   dispatch: PropTypes.func.isRequired,
//   currentUser: PropTypes.shape({ username: PropTypes.string, agency: PropTypes.string }).isRequired,
//   timeZoneOffset: PropTypes.number,
//   mainMenu: PropTypes.arrayOf(PropTypes.any).isRequired,
//   favorite: PropTypes.arrayOf(PropTypes.any).isRequired,
// };

// Header.defaultProps = {
//   timeZoneOffset: null,
// };

// const mapStateToProps = (state) => ({
//   currentUser: state.general.currentUser,
//   timeZoneOffset: state.general.timeZoneOffset,
//   mainMenu: state.general.mainMenu,
//   favorite: state.general.favorite,
// });

// export default connect(mapStateToProps)(Header);
