/* eslint-disable no-lone-blocks */
import React, { Component, useRef, useState } from "react";
import PropTypes from "prop-types";
import { View, Text, Alert, Platform, TouchableOpacity } from "react-native";
import * as Font from "expo-font";
import MultiSelect from 'react-native-multiple-select';
import * as Util from "../../helpers/util";
import * as LocalStorage from "../../service/localStorage";

import {
  setObject,
  sendRefreshRequest,
  setCurrentKeyFocus,
  setCurrentKeyValue,
  askForPossibleValue,
  uploadFile,
  setSearchCriteriaValue,
  setSearchCriteriaOperator,
  sendSearchRequest,
  downloadFile,
  setCurrentObjectPath,
} from "../../redux/actions";
import StringComponent from "./string";
import BooleanComponent from "./boolean";
import NumberComponent from "./number";
import ReadonlyComponent from "./readonly";
import DateComponent from "./date";
import DropdownComponent from "./dropdown";
import AutoCompleteComponent from "./autocomplete";
import FileComponent from "./file";
import MultiStringComponent from "./multi_string";
import ExpressionComponent from "./expression";
import DateRange from "./date_range";
import TemplatesFactory from "./../TemplatesFactory"

// import "../../../node_modules/codemirror/lib/codemirror.css";
// import "../../../node_modules/codemirror/theme/material.css";

import LabelComponent from "./label";
import * as colors from "./../../src-screens/environments/colors";
import Ionicons from "@expo/vector-icons/Ionicons";
import { Entypo } from '@expo/vector-icons';
import { Octicons } from '@expo/vector-icons';
import { InfoCircleOutlined } from "@ant-design/icons";
import { Modal, TextareaItem } from "@ant-design/react-native";
import AwesomeAlert from "react-native-awesome-alerts";
import SwitchWeb from "./switch";
import { Autocomplete, TextField } from "@mui/material";
import AutoCompleteWEB from "./AutoCompleteWeb";
import Swal from "sweetalert2";
import ReadMore from "react-native-read-more-text";
import { Styles } from "../../src-screens/Styles/eliraStyles";
import { getTranslation } from "../../labels";



class EKey extends Component {
  static getObjectFullPath(vs, key, path) {
    console.log(`kkkkjhhfff ${path}`,key)
    return `${(key.isReadOnly === "true" || vs.tdl.type === "SMS") && Util.isSimpleType(key.type)
      ? `${path}${Util.serverFormatPostfix}`
      : path
      }`;
  }

  shouldComponentUpdate(nextProps, nextState) {
    return !Util.isEqual(nextState, this.state);
  }
  static getValue({ key, vs, isSearch, path }) {
    if (isSearch) {
      return vs.getSearchCriteriaValue(key.keyName);
    }
    return vs.getObject(EKey.getObjectFullPath(vs, key, path), "");
  }

  static getDerivedStateFromProps(nextProps) {
    const { vs, tdlPath, isSearch, path, smallView } = nextProps;
    console.log("kmkmjfhjhf",tdlPath)
    const key = vs.getTdlWithPath(tdlPath);
    const value = EKey.getValue({ key, vs, isSearch, path });
    const op = vs.getSearchCriteriaOperator(key.keyName);
    const styleKey = {
      flex: 1,
      width: "100%"
    }
    let span = {
      xxl: smallView ? 6 : 3,
      xl: smallView ? 8 : 6,
      lg: smallView ? 12 : 6,
      md: smallView ? 24 : 12,
      sm: 24,
      xs: 24,
    };

    if (isSearch) {
      if (Util.isRangeOperator(op && op.code)) {
        span = {
          xxl: smallView ? 12 : 6,
          xl: smallView ? 24 : 12,
          lg: smallView ? 24 : 12,
          md: smallView ? 24 : 12,
          sm: 24,
          xs: 24,
        };
      } else {
        span = {
          xxl: smallView ? 8 : 4,
          xl: smallView ? 12 : 8,
          lg: smallView ? 12 : 8,
          md: smallView ? 24 : 12,
          sm: 24,
          xs: 24,
        };
      }
    } else if (key.type === "BlobText" || key.type === "Text") {
      span = {
        xxl: smallView ? 12 : 6,
        xl: smallView ? 12 : 12,
        lg: smallView ? 24 : 12,
        md: 24,
        sm: 24,
        xs: 24,
      };
    }

    return {
      isSearch,
      tdlPath,
      path,
      value,
      key,
      span,
      operators: vs.getSearchCriteriaOperators(tdlPath),
      op,
      usecaseId: vs.usecaseId,

    };
  }

  constructor(props) {
    super(props);
    this.state = {
      url: null,
      isSearch: null,
      tdlPath: null,
      path: null,
      value: null,
      key: null,
      span: null,
      operators: null,
      op: null,
      usecaseId: null,
      openModal: false,
      help: ""
    };
  }

  async componentDidMount() {
    // await Font.loadAsync(
    //   "antoutline",
    //   // eslint-disable-next-line
    //   require("@ant-design/icons-react-native/fonts/antoutline.ttf"),
    // );

    // await Font.loadAsync(
    //   "antfill",
    //   // eslint-disable-next-line
    //   require("@ant-design/icons-react-native/fonts/antfill.ttf"),
    // );
    // eslint-disable-next-line
    this.setState({ isReady: true });
    this.setState({ required: false })
    const storedIsRTL = await LocalStorage.getisRTL();
    console.log("isRtttt", storedIsRTL)

  }

  checkHiddenKeys(vs, key) {
    let hiddenKeys = vs.split(",");
    let check = false;
    hiddenKeys.map((item) => {
      if (item == key) {
        check = true
      }
    })
    console.log("vsssss", hiddenKeys)
    return check;
  }

  checkHiddenLabels(vs, key) {
    let hiddenLabels = vs.split(",");
    let check = false;
    hiddenLabels.map((item) => {
      if (item == key) {
        check = true
      }
    })
    console.log("vsssss", hiddenLabels)
    return check;
  }

  shouldComponentUpdate(nextProps, nextState) {
    return !Util.isEqual(nextState, this.state);
  }

  getKeyFactoryComponent() {
    const { key, isSearch, op } = this.state;
    const { type, isReadOnly, dynamicPossibleValues, hasPVs } = key;
    const { vs } = this.props;
    let isHidden = false;
    console.log("njnjnj 2", key)

    if (this.props.vs.tdl.tdlOptions) {
      const replacedPath =
        this.props.path.replace(/\[[0-9]\]/g, '#*').replace(/\./g, "#");
      console.log("njnjnj 1", this.props.vs.tdl.tdlOptions)

      if (this.props.vs.tdl.tdlOptions[replacedPath]) {
        console.log("njnjnj template", this.props.vs.tdl.tdlOptions[replacedPath].templateName.replace(/["]/g, ""))
        return TemplatesFactory.getTemplate(this.props.vs.tdl.tdlOptions[replacedPath].templateName.replace(/["]/g, ""))
      }
    }
    console.log(`type of key ${type} of name ${key.keyName}`)
    if ((isReadOnly === "true" || vs.tdl.type === "SMS") && !isSearch) return ReadonlyComponent;
    if (isSearch && op && Util.isMultiOperator(op.code)) return MultiStringComponent;
    if (DateRange && op && Util.isRangeOperator(op.code)) return DateRange;
    if (Util.isFileType(type)) return FileComponent;
    if (type === "Expression" && !isSearch) return ExpressionComponent;
    if (type === "Boolean") return Platform.OS == "web" ? SwitchWeb : BooleanComponent;
    if (type === "MultiString") return MultiStringComponent;
    if (type === "Long" || type === "Double") return NumberComponent;
    if (type === "Date" || type === "DateTime" || type === "Time") return DateComponent;
    if (dynamicPossibleValues === "false" && hasPVs === "true") return DropdownComponent;
    if (dynamicPossibleValues === "true") return AutoCompleteComponent;
    if (type === "String" || type === "Password" || type === "Text" || type === "BlobText") return StringComponent;
    if (Util.isSimpleType(type) && hasPVs === "true") return DropdownComponent;
    return StringComponent;
  }

  setValue(val) {
    const { dispatch } = this.props;
    const { usecaseId, isSearch, key, path } = this.state;
    if (isSearch) {
      dispatch(setSearchCriteriaValue(usecaseId, key.keyName, val));
    } else {
      console.log("value");
      console.log({ val })
      console.log({ path })
      dispatch(setObject(usecaseId, path, val));
      if (key.isRefreshable === "true") {
        dispatch(sendRefreshRequest(usecaseId));
      }
    }
  }

  updateModel(val) {
    const { dispatch } = this.props;
    const { usecaseId, isSearch, key, path } = this.state;
    if (isSearch) {
      dispatch(setSearchCriteriaValue(usecaseId, key.keyName, val));
    } else {
      dispatch(setObject(usecaseId, path, val));
    }

  }

  setSearchOperator(opr) {
    const { dispatch } = this.props;
    const { usecaseId, key, operators } = this.state;
    dispatch(
      setSearchCriteriaOperator(
        usecaseId,
        key.keyName,
        operators.find((item) => opr === item.code),
      ),
    );
    this.setValue(null);
  }

  requestForPossibleValue(query) {
    const { dispatch } = this.props;
    const { usecaseId, isSearch, key, path } = this.state;
    dispatch(setCurrentKeyFocus(usecaseId, isSearch ? key.keyName : path));
    dispatch(setCurrentKeyValue(usecaseId, query));
    dispatch(askForPossibleValue(usecaseId));
  }

  downloadFile() {
    const { dispatch, path } = this.props;
    const { usecaseId } = this.state;
    dispatch(setCurrentObjectPath(usecaseId, path));
    dispatch(downloadFile(usecaseId, true));
  }
  handleOk = () => {

    setTimeout(() => {

      this.setState({ openModal: false });
    }, 3000);
  };
  handleCancel = () => {
    this.setState({ openModal: false });
  };
  drawModal = () => {
    console.log("open Modal", this.state.openModal)
    console.log("open Modal help", this.state.help)
    return (
      <Modal
        open={this.state.openModal}
        title=""
        onOk={() => handleOk()}
        onCancel={() => handleCancel()}

      >
        {this.state.help}
      </Modal>
    );
  }
  showAlert = () => {
    this.setState({
      openModal: true,
    });
  };

  showAlertModal = (msg) => {
    console.log("dddcccdd", getTranslation("no"))
    const isRTLWEB = Platform.OS == "web" ? document.getElementsByTagName('html')[0].dir : "rtl";

    Swal.fire({
      title: "",
      text: msg,
      icon: 'question',
      showCancelButton: false,
      confirmButtonColor: '#3085d6',
      cancelButtonColor: '#d33',
      confirmButtonText: isRTLWEB == "rtl" ? "إغلاق" : "cancel"
    }).then((result) => {
      if (result.isConfirmed) {
        // // Swal.fire(
        // //   'Deleted!',
        // //   'Your file has been deleted.',
        // //   'success'
        // // )
        // if (objectPk) {
        //   store.dispatch(setCurrentObjectPath(usecaseId, objectPk));
        // }
        // store.dispatch(confirmAction(usecaseId, tdlId));
        // // AntMessages.destroy(key);
      }
    })
  }

  hideAlert = () => {
    this.setState({
      openModal: false,
    });
  };
  coloringField = (name, value) => {
    let color = "";
    if (name == "cardFound") {
      if (value == "البطاقة غير موجودة يرجى التأكد من أن المعرف الموجود على الشاشة مطابق لمعرف البطاقة"
        || value == "The card was not found. please, make sure the id on the screen is the same as the id of the card") {
        color = "red"
      }
      if (value == "البطاقة موجودة"
      || value == "Card is Found") {
      color = "green"
    }
    }
    if (name == "agentFound") {
      if (value == "حساب العميل غير موجود"
        || value == "Client Account not Found") {
        color = "red"
      }
      if (value == "تم التحقق من وجود حساب العميل"
      || value == "Client Account Validated") {
      color = "green"
    }
    }

    return color;

  }
  render() {
    const { dispatch, timeZoneOffset, vs, isRTL, theme, customStyle, tdlPath, meta, backgroundTheme, isLoading, smsAdvance  } = this.props;
    const { key, isSearch, span, operators, op, value, usecaseId, path, required } = this.state;
    const ComponentToReturn = this.getKeyFactoryComponent();
    const colorOfResult = this.coloringField(key.keyName, value);
    const styleCEV={
      // flex: 1,
      // paddingTop: 10,
      flexDirection: 'column',
      //  alignSelf: 'flex-end',
      // justifyContent: "flex-end",
    }
    const styleSMS={
      flex: 1,
      // paddingTop: 10,
      flexDirection: 'column',
      //  alignSelf: 'flex-end',
      // justifyContent: "flex-end",
    }
    console.log(`searchhhh key ${key.keyName} boolean value ${key.type}`)
    console.log("colorOfResult", tdlPath)
    let isHidden = false;
    let isHiddenLabel = false;
    let readMore = false;
    if (vs && vs.tdl && vs.tdl.tdlOptions && vs.tdl.tdlOptions.clientParams && vs.tdl.tdlOptions.clientParams.hiddenKeys) {
      isHidden = this.checkHiddenKeys(vs.tdl.tdlOptions.clientParams.hiddenKeys, key.keyName)
    }
    if (vs && vs.tdl && vs.tdl.tdlOptions && vs.tdl.tdlOptions.clientParams && vs.tdl.tdlOptions.clientParams.hiddenLabels) {
      isHiddenLabel = this.checkHiddenLabels(vs.tdl.tdlOptions.clientParams.hiddenLabels, key.keyName)
    }
    if (vs && vs.tdl && vs.tdl.tdlOptions && vs.tdl.tdlOptions.clientParams && vs.tdl.tdlOptions.clientParams.readMoreCev) {
      if (vs.tdl.tdlOptions.clientParams.readMoreCev == "true") {
        readMore = true;
        console.log("cdcdcd", readMore)
      }
    }

    if (smsAdvance == false) {
      if (vs && vs.tdl && vs.tdl.tdlOptions && vs.tdl.tdlOptions.clientParams && vs.tdl.tdlOptions.clientParams.smsHiddenKeys) {
        console.log("try sms", vs.tdl.tdlOptions.clientParams.smsHiddenKeys)
        isHidden = this.checkHiddenKeys(vs.tdl.tdlOptions.clientParams.smsHiddenKeys, key.keyName)

      }
    }

    console.log(`smsAdvance keyName ${key.keyName}`, key.label)
    let evaluatedStyle = {}

    // console.log(meta.keyName)
    // console.log(customStyle[meta.keyName])
    const styleCustom = customStyle[path] || customStyle[meta.keyName]
    Util.evalStyle(styleCustom, value, meta, evaluatedStyle)
    let containerStyle = (smsAdvance == false) ? styleSMS : styleCEV


    this.multiSelect = null
    const onClear = () => {
      if (isSearch) this.setValue(null);
      else if (key.dynamicPossibleValues === "true") this.setValue({});
      else this.setValue(null);
    };

    if (key.isMandatory == "true") {
      this.setState({ required: true })
    }
    console.log("kkkeeeyyy", key.help)
    return (

      <>
        {!isHidden &&
          <View
            style={[evaluatedStyle && evaluatedStyle.container ? { ...containerStyle, ...evaluatedStyle.container } : containerStyle, {
              // borderWidth: 0.1,
              borderRadius: 5,
              // borderColor: colors.DARK_GRAY,
              // paddingHorizontal: 20,
              padding: 5,
              paddingVertical: 10,
              // flex: 1,
              // alignItems: 'center',
              // backgroundColor: "#333",
              justifyContent: "flex-end",
              display: "flex",
              flexDirection: "column",
              // width: "100%",
              height: 150,
              marginBottom: smsAdvance == false ? 0 : (Platform.OS == "web" ? (readMore ? 30 : 10) : 10)
              // direction: "rtl",
              // textAlign: "right"

            }]}
            span={isSearch && operators && operators.length ? 18 : 24}
          >
            {(!isHiddenLabel || (!!isSearch)) &&
              <View >

                <LabelComponent

                  tdlPath={tdlPath}
                  label={key.label}
                  required={required}
                  isValue={false}
                  theme={theme}
                  path={path}
                  backgroundTheme={backgroundTheme}
                  customStyle={evaluatedStyle && evaluatedStyle.label ? evaluatedStyle.label : {}}
                  style={{ left: 10, flex: 2, marginTop: smsAdvance == false ? 0 : 10 }}
                  isRTL={isRTL}
                  readMore={readMore}
                  value={value}
                  smsAdvance={smsAdvance}

                />

                <View style={{ flexDirection: 'row-reverse', flex: 1, paddingTop: 5 }}>
                  {(key.help != "" && key.help != undefined) ?
                    <>
                      {Platform.OS != "web" &&
                        <Octicons name="info" size={20} color={colors.GRAY}
                          onPress={() => Alert.alert("", key.help)}
                        />
                      }
                      {Platform.OS == "web" &&
                        <TouchableOpacity onPress={() => {
                          this.setState({ help: key.help })
                          this.showAlertModal(key.help);
                          // this.setState({ openModal: true });

                        }
                        }>
                          <InfoCircleOutlined style={{ fontSize: 20, color: colors.GRAY }} />
                        </TouchableOpacity>
                      }
                    </>
                    :
                    <View />
                  }
                </View>

              </View>
            }
            {!!isSearch && operators && operators.length > 0 && (

              <View style={{ flex: 1 }}>
                <></>
                {/* {Platform.OS == "web" &&
                  <AutoCompleteWEB
                    op={op}
                    operators={operators}
                  />
                } */}
                {Platform.OS != "web" &&
                  <MultiSelect
                    hideTags
                    items={operators}
                    uniqueKey="code"
                    ref={(component) => {
                      this.multiSelect = component;
                    }}
                    onSelectedItemsChange={(val) => {
                      val = val[0];
                      this.setSearchOperator(val);
                    }}
                    // onClearSelector={onClear}
                    selectText={op && op.name}
                    selectedItems={[op && op.code]}
                    altFontFamily="ProximaNova-Light"
                    tagRemoveIconColor="#CCC"
                    tagBorderColor="#CCC"
                    tagTextColor="#CCC"
                    selectedItemTextColor="#CCC"
                    selectedItemIconColor="#CCC"
                    itemTextColor="#000"
                    displayKey="name"
                    searchInputStyle={{ color: "#CCC" }}
                    submitButtonColor="#CCC"
                    single={true}


                  />
                }
                <View>{this.multiSelect != null && this.multiSelect.getSelectedItemsExt(operators)}</View>
              </View>
            )}


            <View style={{ flex: 1 }}>

              <ComponentToReturn
                vs={this.props.vs}
                meta={key}
                value={value}
                timeZoneOffset={timeZoneOffset}
                isSearch={isSearch}
                readMore={readMore}
                smsAdvance={smsAdvance}
                colorOfResult={colorOfResult}
                onKeyUp={
                  isSearch
                    ? (e) => {
                      if (e.keyCode === 13) {
                        dispatch(sendSearchRequest(usecaseId));
                      }
                    }
                    : null
                }
                onClear={onClear}
                uploadLabel={getTranslation("clickToUpload")}
                onUpload={(file) => {
                  dispatch(
                    sendRefreshRequest(usecaseId, true, (response) => {
                      if (Util.isSuccessResponse(response)) {
                        dispatch(setCurrentKeyFocus(usecaseId, path));
                        dispatch(uploadFile(usecaseId, file, vs.replaceIndexWithPK(path)));
                      }
                    }),
                  );
                }}
                onQuery={(query) => {
                  this.requestForPossibleValue(query);
                }}
                onChange={(val) => {
                  this.setValue(val);
                }}
                onInputChange={(val) => {
                  this.updateModel(val)
                }}
                downloadFile={() => {
                  this.downloadFile();
                }}
                downloadLabel={getTranslation("download")}
                theme={theme}
                path={path}

                customStyle={evaluatedStyle && evaluatedStyle.value ? evaluatedStyle.value : {}}
                isRTL={isRTL}
                isLoading={isLoading}
              />
            </View>
            {/* {smsAdvance == false && 
            <View style={{backgroundColor:"#c4cbd3" , width:"100%" , height:"1px" , marginTop:5}}>
              </View>
            } */}


          </View>
        }
      </>



    );
  }
}

EKey.propTypes = {
  tdlPath: PropTypes.string.isRequired,
  vs: PropTypes.objectOf(PropTypes.any).isRequired,
  path: PropTypes.string.isRequired,
  dispatch: PropTypes.func.isRequired,
  isSearch: PropTypes.bool,
  smallView: PropTypes.bool,
  theme: PropTypes.any.isRequired,
};

EKey.defaultProps = {
  isSearch: false,
  smallView: false,
};

export default EKey;
