import React, { useEffect, useState } from "react";
import PropTypes from "prop-types";
import { Platform, Text, TextA } from "react-native";
import * as Util from "../../helpers/util";
import HTMLValue from "../htmlValue";
import { TextareaItem } from "@ant-design/react-native";
import ReadMore from 'react-native-read-more-text';
import * as colors from "./../../src-screens/environments/colors";
import { Styles } from './../../src-screens/Styles/eliraStyles'
import { getTranslation } from "./../../src-screens/eLira-labels";
import { View } from "react-native";
// import { Box, Modal, Typography } from "@mui/material";
import { Button, Modal } from 'antd';

const LabelComponent = ({ tdlPath, label, required, isValue, theme, isRTL, customStyle, path, meta, value, backgroundTheme, readMore, smsAdvance, colorOfResult }) => {
  // Util.evalStyle(customStyle, label, meta)
  const [isModalOpen, setIsModalOpen] = useState(false);

  const isRTLWEB = Platform.OS == "web" ? document.getElementsByTagName('html')[0].dir : "rtl";
  console.log("read from server", readMore)
  // console.log("read from server label", value)
  let labelStyle = {
    flex: theme.keyLabel.flex,
    flexDirection: isRTL ? 'row-reverse' : 'row',
    fontSize: theme.fontSize,
    fontFamily: isValue ? "AlmaraiLight" : "AlmaraiRegular",
    textAlign: isRTL ? 'right' : 'left',

  };
  let readmoreStyle = { color: colors.BLACK, fontSize: theme.keyReadmore.fontSize, textAlign: theme.keyReadmore.textAlign }

  if (customStyle) {
    labelStyle = { ...labelStyle, ...customStyle }
  }

  if (customStyle) {
    readmoreStyle = { ...readmoreStyle, ...customStyle }
  }
  // if (keyName == "tandC")
  // console.log("fffdddd", keyName)

  if (Util.isHTML(label)) return <HTMLValue value={label} />;
  if (!label || label.length < 100) {
    return <Text
      textBreakStrategy={'simple'}
      style={[labelStyle, { color: colorOfResult ? colorOfResult : "#333" }]} >
      {label}
      {required == true ? <Text style={{ color: colors.RED }}>*</Text> : <></>}</Text>;
  }

  const showModal = () => {
    setIsModalOpen(true);
  };

  const handleOk = () => {
    setIsModalOpen(false);
  };

  const handleCancel = () => {
    setIsModalOpen(false);
  };



  return <>
    <ReadMore
      numberOfLines={5}
      renderTruncatedFooter={(handlePress) => {
        return (<Text style={[Styles.readmoreStyling, { borderBottomWidth: theme.keyReadmore.borderBottomWidth, borderBottomColor: colors.SEASHELL }]} onPress={handlePress}>{getTranslation("more")}</Text>
          // المزيد .. </Text>
        );
      }}
      renderRevealedFooter={(handlePress) => {
        return (<Text style={Styles.readmoreStyling} onPress={handlePress}>
          {getTranslation("less")} </Text>
        );
      }}


    >
      <Text style={[Styles.textStyle, { fontSize: theme.keyText.fontSize }]}>
        {label}

      </Text>
    </ReadMore>

    {Platform.OS == "web" &&
      <>
        <View style={{ width: "100%", backgroundColor:"pink", marginBottom: 0 }}>
          {readMore == true &&

            <>
              {readMore == false &&

                <>

                  {smsAdvance == false &&
                    <View>
                      <Text>{label.substring(0, 50)}...</Text>
                    </View>
                  }
                  {smsAdvance == true &&
                    <View>
                      <Text>{label}</Text>
                    </View>
                  }
                </>

              }
            </>
          }
        </View>
      </>
    }

    {/* {Platform.OS == "web" &&
      <>


        <View style={{ width: "100%", marginBottom: 0 }}>
          {readMore == true &&
            <>
              {label &&
                <>
                  <Text style={{ color: "#333" }}>

                    {label.substring(0, 100)}
                  </Text>
                  <Text style={{ color: "#5d9fd6" }} onPress={() => setIsModalOpen(true)}>{getTranslation("more")}</Text>
                </>
              }
            </>
            // <TextareaItem
            //   placeholder={label}
            //   rows={5}
            //   count={300}
            //   style={{ height: 80, direction: "rtl", textAlign: "right", border: "2px solid #a7a0a0" }}
            // />
          }

          {readMore == false &&

            <>
              {(smsAdvance != true && smsAdvance != false) &&
                <ReadMore
                  numberOfLines={5}
                  renderTruncatedFooter={(handlePress) => {
                    return (<Text style={[Styles.readmoreStyling, { borderBottomWidth: theme.keyReadmore.borderBottomWidth, borderBottomColor: colors.SEASHELL }]} onPress={handlePress}>{getTranslation("more")}</Text>
                      // المزيد .. </Text>
                    );
                  }}
                  renderRevealedFooter={(handlePress) => {
                    return (<Text style={Styles.readmoreStyling} onPress={handlePress}>
                      {getTranslation("less")} </Text>
                    );
                  }}


                >
                  <Text style={[Styles.textStyle, { fontSize: theme.keyText.fontSize }]}>
                    {label}

                  </Text>
                </ReadMore>
              }
              {smsAdvance == false &&
                <View>
                  <Text>{label.substring(0, 50)}...</Text>
                </View>
              }
              {smsAdvance == true &&
                <View>
                  <Text>{label}</Text>
                </View>
              }
            </>

          }

        </View>






      </>
    }
    {Platform.OS != "web" &&
      <>


        <View style={{ width: "100%", marginBottom: 30 }}>

          <ReadMore
            numberOfLines={5}
            renderTruncatedFooter={(handlePress) => {
              return (<Text style={[Styles.readmoreStyling, { borderBottomWidth: theme.keyReadmore.borderBottomWidth, borderBottomColor: colors.SEASHELL }]} onPress={handlePress}>{getTranslation("more")}</Text>
                // المزيد .. </Text>
              );
            }}
            renderRevealedFooter={(handlePress) => {
              return (<Text style={Styles.readmoreStyling} onPress={handlePress}>
                {getTranslation("less")} </Text>
              );
            }}


          >
            <Text style={[Styles.textStyle, { fontSize: theme.keyText.fontSize }]}>
              {label}

            </Text>
          </ReadMore>

        </View>
      </>
    } */}
    {/* <Modal
      aria-labelledby="spring-modal-title"
      aria-describedby="spring-modal-description"
      open={isModalOpen}
      onClose={handleCancel}
      closeAfterTransition
    // slots={{ backdrop: Backdrop }}
    // slotProps={{
    //   backdrop: {
    //     TransitionComponent: Fade,
    //   },
    // }}
     style={{  textAlign:isRTLWEB=="rtl" ?"right":"left",}}

    >
      <View style={{
        width: 500, height: 500, backgroundColor: "white",
        position: 'absolute',
        top: '50%',
        
        right:'15%',
        // left: isRTL?'':'20%',
        transform: 'translate(-50%, -50%)',
        width: 500,
        height: "60%",
        overflowY:"scroll",
        // bgcolor: 'white',
        // border: '2px solid #000',
        boxShadow: 24,
        textAlign:isRTLWEB=="rtl" ?"right":"left",
        padding:5
      }}>
          <Text style={{ textAlign:isRTLWEB=="rtl" ?"right":"left",}}> {label}</Text>
      </View>
    
    </Modal> */}
    <Modal
      open={isModalOpen}
      onOk={handleOk}
      onCancel={handleCancel}
      footer={[
        <Button key="ok" onClick={handleOk} style={{ backgroundColor: "#5d9fd6", color: "#fff" }}>
          ok
        </Button>,

      ]}
      style={{ height: "80%", overflowY: "scroll", backgroundColor: "white" }}
    >
      {label}
    </Modal>
    {/* { ((Platform.OS == "web" && readMore == false) || (Platform.OS != "web"))&&
      <View style={{ width: "100%", height: "100%" }}>
        <ReadMore
          numberOfLines={5}
          renderTruncatedFooter={(handlePress) => {
            return (<Text style={[Styles.readmoreStyling, { borderBottomWidth: theme.keyReadmore.borderBottomWidth, borderBottomColor: colors.SEASHELL }]} onPress={handlePress}>{getTranslation("more")}</Text>
              // المزيد .. </Text>
            );
          }}
          renderRevealedFooter={(handlePress) => {
            return (<Text style={Styles.readmoreStyling} onPress={handlePress}>
              {getTranslation("less")} </Text>
            );
          }}

        >
          <Text style={[Styles.textStyle, { fontSize: theme.keyText.fontSize }]}>
            {label}

          </Text>
        </ReadMore>

      </View>
    } */}


  </>

};

LabelComponent.propTypes = {
  label: PropTypes.string,
  isValue: PropTypes.bool,
  theme: PropTypes.any.isRequired,
  isRTL: PropTypes.bool.isRequired,
  customStyle: PropTypes.objectOf(PropTypes.any)
};

LabelComponent.defaultProps = {
  label: null,
  isValue: false,
  customStyle: {}
};

export default LabelComponent;
