import React, { useState, useEffect, useRef } from "react";
import { View } from '@ant-design/react-native';
import PropTypes from "prop-types";
import MultiSelect from 'react-native-multiple-select';
import * as colors from './../../src-screens/environments/colors'
import { Styles } from "../../src-screens/Styles/eliraStyles";
import { evalStyle } from "../../helpers/util";
import { Platform } from "react-native";


const MultiStringComponent = ({ meta, value, onChange, onClear, onQuery,
  isSearch, onKeyUp, theme, customStyle, tdlPath, path }) => {

  const { pv, isMandatory, hasPVs, dynamicPossibleValues } = meta;
  const [currentValue, setCurrentValue] = useState("");
  console.log("pppppvvvvv", pv)
  useEffect(() => {
    if (hasPVs === "true" && dynamicPossibleValues === "true") onQuery("");
  }, []);
  const multiSelect = useRef(null)
  // evalStyle(customStyle,value,meta)
  const setValue = (values) => {
    if (hasPVs === "false") {
      onChange(values ? values.filter((val) => !!val) : []);
    } else if (values && Array.isArray(values)) {
      if (isSearch) {
        onChange(values || []);
      } else {
        onChange(values ? values.map((item) => ({ pk: item, label: item })) : []);
      }
    } else {
      onChange([]);
    }
    setCurrentValue("");
  };
  if (hasPVs === "true") {
    let selectedItems = [];
    if (isSearch) {
      selectedItems = value && Array.isArray(value) ? value : [];
    } else {
      selectedItems = value && Array.isArray(value) ? value.map((item) => item.pk) : [];
    }
    return (
      <>
        {Platform.OS == "web" &&
          <Autocomplete
            value={value && value._label || ""}
            blurOnSelect={true}
            onChange={setValue}
            onKeyDown={(e) => {
              console.log("e.keyCode", e.keyCode)
              if (e.keyCode === 9) e.preventDefault();
            }}
            filterOptions={(options, params) => {
              const filtered = filter(options, params);

              const { inputValue } = params;
              // Suggest the creation of a new value
              const isExisting = options.some((option) => inputValue === option._label);
              if (inputValue !== '' && !isExisting) {
                filtered.push({
                  inputValue,
                  _label: `Add "${inputValue}"`,
                });
              }

              return filtered;
            }}
            open={listIsOpened}
            onOpen={() => {
              if (!pv || pv.length === 0) onQuery("");
              setListIsOpened(true)
            }}
            onClose={() => {
              setListIsOpened(false);
            }}
            selectOnFocus
            clearOnBlur
            handleHomeEndKeys
            id="pk"
            options={pv}
            getOptionLabel={(option) => {
              // Value selected with enter, right from the input
              if (typeof option === 'string') {
                return option;
              }
              // Add "xxx" option created dynamically
              if (option.inputValue) {
                return option.inputValue;
              }
              // Regular option
              return option._label;
            }}
            renderOption={(props, option) => <li {...props}>{option._label}</li>}
            sx={{ width: 300 }}
            freeSolo
            renderInput={(params) => (
              <TextField {...params} label="" />
            )}
            uniqueKey="pk"
            ref={(component) => { multiSelect.current = component }}
            style={{ width: "100%", textAlign: isRTL ? 'right' : 'left' }}
          />
        }
        {Platform.OS != "web" &&
          <MultiSelect
            hideTags
            items={pv}
            uniqueKey="pk"
            ref={(component) => { multiSelect.current = component }}
            onSelectedItemsChange={setValue}
            styleDropdownMenu={[Styles.borderStyle, theme.keyMultiSelect]}
            selectedItems={selectedItems}
            altFontFamily="ProximaNova-Light"
            tagRemoveIconColor="#CCC"
            tagBorderColor="#CCC"
            tagTextColor="#CCC"
            // selectedItemIconColor="#CCC"
            // itemTextColor="#000"
            displayKey="name"
            searchInputStyle={{ color: '#CCC' }}
            submitButtonColor="#CCC"
            single={false}
            itemFontSize={14}
            fontSize={18}
            selectedItemTextColor={colors.Cutty_Sark}
            selectedItemIconColor={colors.Cutty_Sark}
            itemTextColor={colors.BLACK}
            textColor={colors.DARK_GRAY}


          />
        }
        <View>
          {multiSelect.getSelectedItemsExt(selectedItems)}
        </View>
      </>
      // <Select
      //   mode="multiple"
      //   allowClear={isMandatory === "false" || isSearch}
      //   onClear={onClear}
      //   style={{ width: "100%" }}
      //   value={selectedItems}
      //   onChange={setValue}
      //   onKeyUp={onKeyUp}
      //   onSearch={dynamicPossibleValues === "true" ? onQuery : null}
      // >
      //   {pv &&
      //     pv.map((item) => (
      //       <Select.Option key={item.pk} value={item.pk} title={item._label}>
      //         {item._label}
      //       </Select.Option>
      //     ))}
      // </Select>
    );
  }
  return (
    <>
      {Platform.OS == "web" &&
        <Autocomplete
          value={value}
          blurOnSelect={true}
          onChange={(str) => {
            setCurrentValue(str);
          }}
          onKeyDown={(e) => {
            console.log("e.keyCode", e.keyCode)
            if (e.keyCode === 9) e.preventDefault();
          }}
          filterOptions={(options, params) => {
            const filtered = filter(options, params);

            const { inputValue } = params;
            // Suggest the creation of a new value
            const isExisting = options.some((option) => inputValue === option._label);
            if (inputValue !== '' && !isExisting) {
              filtered.push({
                inputValue,
                _label: `Add "${inputValue}"`,
              });
            }

            return filtered;
          }}
          open={listIsOpened}
          onOpen={() => {
            if (!pv || pv.length === 0) onQuery("");
            setListIsOpened(true)
          }}
          onClose={() => {
            setListIsOpened(false);
          }}
          selectOnFocus
          clearOnBlur
          handleHomeEndKeys
          id="pk"
          options={pv}
          getOptionLabel={(option) => {
            // Value selected with enter, right from the input
            if (typeof option === 'string') {
              return option;
            }
            // Add "xxx" option created dynamically
            if (option.inputValue) {
              return option.inputValue;
            }
            // Regular option
            return option._label;
          }}
          renderOption={(props, option) => <li {...props}>{option._label}</li>}
          sx={{ width: 300 }}
          freeSolo
          renderInput={(params) => (
            <TextField {...params} label="" />
          )}
          uniqueKey="pk"
          ref={(component) => { multiSelect.current = component }}
          style={{ width: "100%", textAlign: isRTL ? 'right' : 'left' }}
        />
      }
      {Platform.OS != "web" &&
        <MultiSelect
          hideTags
          items={pv}
          uniqueKey="pk"
          ref={(component) => { multiSelect.current = component }}
          onSelectedItemsChange={setValue}
          onChangeInput={(str) => {
            setCurrentValue(str);
          }}
          onClearSelector={onClear}
          selectedItems={value}
          altFontFamily="ProximaNova-Light"
          tagRemoveIconColor="#CCC"
          tagBorderColor="#CCC"
          tagTextColor="#CCC"
          selectedItemTextColor="#CCC"
          selectedItemIconColor="#CCC"
          itemTextColor="#000"
          displayKey="_label"
          searchInputStyle={{ color: '#CCC' }}
          submitButtonColor="#CCC"
          single={false}
        />
      }
      <View>
        {multiSelect.getSelectedItemsExt([currentValue])}
      </View>
    </>


  );
};

MultiStringComponent.propTypes = {
  meta: PropTypes.objectOf(PropTypes.any).isRequired,
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.array]),
  onChange: PropTypes.func.isRequired,
  onClear: PropTypes.func.isRequired,
  onQuery: PropTypes.func.isRequired,
  isSearch: PropTypes.bool.isRequired,
  onKeyUp: PropTypes.func,
  theme: PropTypes.objectOf(PropTypes.any),
  customStyle: PropTypes.objectOf(PropTypes.any)
};

MultiStringComponent.defaultProps = {
  value: null,
  onKeyUp: null,
  customStyle: {}
};

export default MultiStringComponent;




