import React from "react";
import { Stepper } from '@ant-design/react-native';
import PropTypes from "prop-types";
import * as colors from './../../src-screens/environments/colors'
import { Styles } from "../../src-screens/Styles/eliraStyles";
import { evalStyle } from "../../helpers/util";

const NumberComponent = ({ meta, value, onChange, theme, customStyle, tdlPath, path }) => {
  // evalStyle(customStyle, value, meta)
  let valueStyle = {

    // marginLeft: -40,
    // marginRight: 5,

  }
  if (customStyle) {
    valueStyle = { ...valueStyle, ...customStyle }

  }
  return <Stepper
    style={[Styles.borderStyle, valueStyle]}
    step={100}
    min={meta.min}
    max={meta.max}
    defaultValue={value && value || 0.0}
    value={value && value || 0.0}
    onChange={(val) => {
      onChange(val);
    }}
    customStyle={customStyle}

  />


};

NumberComponent.propTypes = {
  meta: PropTypes.objectOf(PropTypes.any).isRequired,
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  onChange: PropTypes.func.isRequired,
  theme: PropTypes.objectOf(PropTypes.any),
  customStyle: PropTypes.objectOf(PropTypes.any)
};

NumberComponent.defaultProps = {
  value: null,
};

export default NumberComponent;
