/* eslint-disable no-underscore-dangle */
import React from "react";
import { InputItem, TextareaItem } from "@ant-design/react-native";
import PropTypes from "prop-types";
import * as Util from "../../helpers/util";
import HTMLValue from "../htmlValue";
import LabelComponent from "./label";
import { Styles } from "../../src-screens/Styles/eliraStyles";
import {colors} from "../../src-screens/environments/colors"
import { View } from "react-native";

const ReadOnlyComponent = ({vs, meta, value, theme, tdlPath, path, customStyle,isRTL ,readMore,smsAdvance ,colorOfResult}) => {
  const { type, label } = meta;

  // Util.evalStyle(customStyle, value, meta)
  // console.log("in readOnly")

  if (Util.isHTML(value)) return <View style={{height:100}}><HTMLValue value={value}  /></View>;

  const fixedValue = typeof value === "object" ? (value && value._label) || "" : value;

  let valueStyle = theme.keyValue;
  if (customStyle) {
    valueStyle = { ...valueStyle, ...customStyle }

  }
  console.log("read only rtl", value)
  return <LabelComponent
    style={[Styles.borderStyle, valueStyle,{  textAlign: isRTL ? 'right' : 'left'}]}
    label={fixedValue}
    isValue={true}
    theme={theme}
    customStyle={customStyle}
    isRTL={isRTL}
    readMore={readMore}
    smsAdvance={smsAdvance}
    colorOfResult={colorOfResult}
    />;
};

ReadOnlyComponent.propTypes = {
  meta: PropTypes.objectOf(PropTypes.any).isRequired,
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  theme: PropTypes.objectOf(PropTypes.any).isRequired,
};

ReadOnlyComponent.defaultProps = {
  value: null,
  customStyle: {}
};

export default ReadOnlyComponent;
