import React, { useRef, useEffect, useState } from "react";
import { InputItem, TextareaItem } from '@ant-design/react-native';
import PropTypes from "prop-types";
import * as colors from "./../../src-screens/environments/colors";
import { Styles } from './../../src-screens/Styles/eliraStyles'
import { evalStyle } from "../../helpers/util";
import { View } from "native-base";
import Icon from "react-native-vector-icons/FontAwesome5";
import { Platform ,TouchableOpacity } from "react-native";
import { EyeInvisibleOutlined, EyeOutlined } from "@ant-design/icons";

const StringComponent = ({ vs, meta, value, onChange, onInputChange, isSearch, readMore, theme, customStyle, tdlPath, isRTL, path }) => {
  // evalStyle(customStyle, value, meta)
  const [textType, setTextType] = useState('Text');
  const [hidePass, setHidePass] = useState(true);

  console.log("bfbf readMore", readMore)
  let feildHidden = 1;
  if (vs && vs.tdl && vs.tdl.tdlOptions && vs.tdl.tdlOptions[meta.keyName] && vs.tdl.tdlOptions[meta.keyName]["feildHidden"] == "true") {

    feildHidden = 0;
    // console.log({ feildHidden })
  }
  console.log("label najj", meta)
  let textAreaItemStyle = {
    flex: theme.keyTextArea.flex,
    justifyContent: theme.keyTextArea.justifyContent,
    // marginLeft: -40,
    // marginRight: 5,
    textAlign: isRTL ? 'right' : 'left',
    //  backgroundColor:"blue",
    opacity: feildHidden
  };
  if (customStyle) {
    textAreaItemStyle = { ...textAreaItemStyle, ...customStyle }
  }

  let inputItemStyle = {
    justifyContent: theme.keyInputItem.justifyContent,
    color: theme.keyInputItem.color,
    textAlign: isRTL ? 'right' : 'left',
  }

  if (customStyle) {
    inputItemStyle = { ...inputItemStyle, ...customStyle }
  }

  let disabled = false;
  if (customStyle) {
    disabled = customStyle.disabled
  }



  let contextMenuHidden = false;
  if (vs.tdl && vs.tdl.tdlOptions && vs.tdl.tdlOptions[meta.keyName] && vs.tdl.tdlOptions[meta.keyName]["copyPasteProtection"] == "true") {
    contextMenuHidden = true
  }


  const { type, label, help, isMandatory } = meta;
  if (!isSearch && (type === "BlobText" || type === "Text")) {

    return (
      <View style={{ backgrounColor:"pink",justifyContent: theme.keyView.justifyContent, width: "95%" ,maginTop:"2%",marginBottom:"2%" }}>
        <TextareaItem
          style={[Styles.borderStyle, textAreaItemStyle]}
          // placeholder={help}
          rows={2}
          value={value}
          onChange={(v) => {
            onChange(v);
          }}


          customStyle={customStyle}
        />
      </View>

    );
  }

  if (type == "Password") {
    return (<View style={{ flex: theme.keyView.flex, justifyContent: theme.keyView.justifyContent, width: "100%" , }}>
      <View style={{ display:"flex" ,flexDirection:"row-reverse"}}>
  

{Platform.OS != "web" &&
        <Icon
          adjustsFontSizeToFit
          name={hidePass ? "eye-slash" : "eye"}
          size={15}
          color="grey"
          onPress={() => setHidePass(!hidePass)}
          style={[Styles.borderStyle, inputItemStyle, theme.keyIcon]}
        />
      }
      {Platform.OS == "web" &&
        <>
          {hidePass &&
            <TouchableOpacity onPress={() => setHidePass(!hidePass)}>
              <EyeInvisibleOutlined
                style={{
                  flexDirection: 'row',
                  alignSelf: 'flex-end',
                  paddingLeft: 30,
                  left: -20,
                  top: -30,
                  // backgroundColor:"red",
                  marginTop: 10,
                  marginBottom: 10,
                  fontSize: 20,
                  color: "grey"
                }}
              />
            </TouchableOpacity>
          }
          {!hidePass &&
            <TouchableOpacity onPress={() => setHidePass(!hidePass)}>
              <EyeOutlined style={{
                flexDirection: 'row',
                alignSelf: 'flex-end',
                paddingLeft: 30,
                left: -20,
                top: -30,
                marginTop: 10,
                marginBottom: 10,
                fontSize: 20,
                color: "grey"
              }} />
            </TouchableOpacity>}
        </>


      }

<View style={{flex:1}}>
      <InputItem
        adjustsFontSizeToFit
        transparent
        secureTextEntry={value}
        type={hidePass ? "password" : ""}
        onChangeText={(v) => {
          onInputChange(v)
        }}
        onBlur={(v) => {
          onChange(v);
        }}
        value={value}
        disabled={disabled}
        contextMenuHidden={true}
        selectTextOnFocus={false}
        customStyle={customStyle}
        style={[Styles.borderStyle, inputItemStyle,]}
      />
      </View>
    
      </View>
    </View>
    )

  }

  return (
    <View style={{ flex: theme.keyView.flex, justifyContent: theme.keyView.justifyContent, width: "95%" }}>
      <InputItem
        style={[Styles.borderStyle, inputItemStyle, { textAlign: isRTL ? 'right' : 'left', width: "100%" }]}
        // clear
        type={"text"}
        value={value}
        onChange={(v) => {
          onInputChange(v)
        }}
        onBlur={(v) => {
          onChange(v);
        }}
        disabled={disabled}
        contextMenuHidden={true}
        selectTextOnFocus={false}
        customStyle={customStyle}

      />
    </View>
  );
};

StringComponent.propTypes = {
  meta: PropTypes.objectOf(PropTypes.any).isRequired,
  value: PropTypes.string,
  onChange: PropTypes.func.isRequired,
  isSearch: PropTypes.bool.isRequired,
  theme: PropTypes.objectOf(PropTypes.any),
  customStyle: PropTypes.objectOf(PropTypes.any),
};

StringComponent.defaultProps = {
  value: null,
};

export default StringComponent;
