// import React, { useState, useEffect } from "react";
// import PropTypes from "prop-types";
// import { connect } from "react-redux";
// import { Tabs as AntTabs, Modal } from "antd";
// import TDL from "./tdl/index";
// import Dashboard from "./dashboard";
// import { changeActiveTab, createNewTab, closeTab, closeUsecaseId } from "../redux/actions";
// import { getTranslation } from "../labels";

// const { TabPane } = AntTabs;

// const TabsComponent = ({
//   tabs,
//   viewStatuses,
//   dispatch,
//   currentActiveTab,
//   favorite,
//   timeZoneOffset,
//   isLoading,
// }) => {
//   const [popupUsecaseId, setPopupUsecaseId] = useState(null);

//   const getTabHeader = (id, vs) => {
//     if (isLoading && id === currentActiveTab) return getTranslation("loading");
//     if (!vs) return getTranslation("newTab");
//     if (vs.callersLabelsArray.length > 0) {
//       return vs.callersLabelsArray[0].tdlLabel;
//     }
//     return vs.tdlLabel;
//   };

//   useEffect(() => {
//     setPopupUsecaseId(tabs.find((item) => item.id === "popup").usecaseId);
//   }, [tabs]);

//   return (
//     <>
//       <Modal
//         destroyOnClose
//         visible={popupUsecaseId}
//         footer={null}
//         width={Math.max(document.documentElement.clientWidth || 0, window.innerWidth || 0) * 0.8}
//         onCancel={() => {
//           dispatch(closeTab("popup"));
//           dispatch(closeUsecaseId(popupUsecaseId));
//         }}
//       >
//         <TDL
//           dispatch={dispatch}
//           vs={viewStatuses[popupUsecaseId]}
//           favorite={favorite}
//           timeZoneOffset={timeZoneOffset}
//         />
//       </Modal>
//       <AntTabs
//         type="editable-card"
//         onChange={(activeKey) => {
//           dispatch(changeActiveTab(activeKey));
//         }}
//         activeKey={currentActiveTab}
//         onEdit={(targetKey, action) => {
//           if (action === "add") {
//             dispatch(createNewTab(null));
//           } else if (action === "remove") {
//             dispatch(closeTab(targetKey));
//             const { usecaseId } = tabs.find((item) => item.id === targetKey);
//             if (usecaseId) {
//               dispatch(closeUsecaseId(usecaseId));
//             }
//           }
//         }}
//         size="small"
//       >
//         <TabPane closable={false} tab={getTranslation("home")} key="home">
//           <Dashboard dispatch={dispatch} />
//         </TabPane>
//         {tabs
//           .filter((tab) => tab.mainTab !== false)
//           .map((item) => {
//             const { id, usecaseId } = item;
//             const vs = viewStatuses[usecaseId];
//             return (
//               <TabPane tab={getTabHeader(id, vs)} key={`${id}`}>
//                 {vs && <TDL vs={vs} />}
//               </TabPane>
//             );
//           })}
//         {isLoading && tabs.filter((item) => item.mainTab !== false).length === 0 && (
//           <TabPane closable={false} tab={getTranslation("loading")} key="loadingTab" disabled />
//         )}
//       </AntTabs>
//     </>
//   );
// };

// TabsComponent.propTypes = {
//   tabs: PropTypes.arrayOf(PropTypes.any).isRequired,
//   viewStatuses: PropTypes.objectOf(PropTypes.any).isRequired,
//   currentActiveTab: PropTypes.string,
//   dispatch: PropTypes.func.isRequired,
//   favorite: PropTypes.arrayOf(PropTypes.any).isRequired,
//   timeZoneOffset: PropTypes.number.isRequired,
//   isLoading: PropTypes.bool.isRequired,
// };

// TabsComponent.defaultProps = {
//   currentActiveTab: null,
// };

// const mapStateToProps = (state) => ({
//   viewStatuses: state.viewStatus,
//   tabs: state.tabs.tabs,
//   currentActiveTab: state.tabs.currentActiveTab,
//   favorite: state.general.favorite,
//   timeZoneOffset: state.general.timeZoneOffset,
//   isLoading: state.general.isLoading,
// });

// export default connect(mapStateToProps)(TabsComponent);
