import React, { useEffect, useState } from "react";
import PropTypes from "prop-types";
import { KeyboardAwareScrollView } from "react-native-keyboard-aware-scrollview";
import { ScrollView, View } from "react-native";
import EKey from "../key/key";
import GenericGroup from "./index";
import { SMS_Keys } from "./../../config/options"
import { deviceHeight } from "../../helpers/util";
import { getTheme } from "../../styles/themes";
import { Text } from "react-native";
// import {SMS_KEYS_COUNT} from '@env'


const extractPropsFromVs = ({ vs, tdlPath, path, isSearch }) => {
    const { usecaseId } = vs;
    const group = vs.getTdlWithPath(tdlPath);
    const object = isSearch ? vs.getSearchCriteriaObject() : vs.getObject(path, "");
    return {
        usecaseId,
        object,
        group,
    };
};

const GroupSlice = ({ isSearch, tdlPath, path, vs, dispatch, timeZoneOffset, smallView, isRTL, isSMSRow, theme, customStyle, isLoading, smsAdvance, groups, ContainerComponent,
    pageNumber }) => {
    const { group } = extractPropsFromVs({ vs, tdlPath, path, isSearch });
    const [sliceNumber, setSliceNumber] = useState(0);
    // const theme = getTheme(themeName);
    console.log("hidden keys", theme.groupsContainerComponent)
    //   const keysToShow = isSMSRow ? SMS_Keys : group[0].subGroups[0].length
    //   const ContainerComponent = isSMSRow ? View : View;
    const [count, setCount] = useState(0);



    useEffect(() => {

        // if(pageNumber >= 0 && pageNumber <= groups.length-1){
        //     setSliceNumber(pageNumber)
        // }
        console.log("subGroupsjj", groups[pageNumber])
    }, [pageNumber])

    return (
        <ContainerComponent >

            <View style={{alignItems:"flex-start" , marginTop:5}}>
                <Text style={{  color: "#7a858a", fontSize: 18 }}>
                    {groups[pageNumber].label}
                </Text>
            </View>

            {groups[pageNumber] && groups[pageNumber].subGroups[0] && groups[pageNumber].subGroups[0].keys &&
                groups[pageNumber].subGroups[0].keys.slice(0, groups[pageNumber].subGroups[0].keys.length).map((key, index) => (
                    //TODO check if key is inside isHidden
                    // <></>
                    <EKey
                        key={`${key.pk}_Key`}
                        path={key.keyName}
                        tdlPath={`groups-0.subGroups-${pageNumber}.subGroups-0.keys.${index}`}
                        isSearch={isSearch}
                        vs={vs}
                        dispatch={dispatch}
                        timeZoneOffset={timeZoneOffset}
                        smallView={smallView}
                        isRTL={isRTL}
                        theme={theme}
                        customStyle={{ backgroundColor: "transparent" }}
                        meta={vs.getTdlWithPath(`groups-0.subGroups-${pageNumber}.subGroups-0.keys.${index}`)}
                        isLoading={isLoading}
                        smsAdvance={smsAdvance}
                        count={count}

                    />

                ))}
            {/* {!isSMSRow && group.subGroups &&
        group.subGroups.map(({ id }, index) => (
          <GenericGroup
            key={id}
            path={path}
            tdlPath={`${tdlPath}.subGroups.${index}`}
            vs={vs}
            isSearch={isSearch}
            dispatch={dispatch}
            timeZoneOffset={timeZoneOffset}
            isRTL={isRTL}
            theme={theme}
            customStyle={customStyle}
            isLoading={isLoading}
            
          />
        ))} */}


        </ContainerComponent>

    );
};

GroupSlice.propTypes = {
    vs: PropTypes.objectOf(PropTypes.any).isRequired,
    tdlPath: PropTypes.string.isRequired,
    path: PropTypes.string.isRequired,
    isSearch: PropTypes.bool,
    dispatch: PropTypes.func.isRequired,
    timeZoneOffset: PropTypes.number.isRequired,
    smallView: PropTypes.bool,
    isRTL: PropTypes.bool.isRequired,
    isSMSRow: PropTypes.bool,
    theme: PropTypes.objectOf(PropTypes.any).isRequired,
    customStyle: PropTypes.objectOf(PropTypes.any)
};

GroupSlice.defaultProps = {
    isSearch: false,
    smallView: false,
    isSMSRow: false,
    customStyle: {}
};

// export default React.memo(SimpleGroup, (prevProps, nextProps) => {
//   if (!nextProps.path) {
//     return false;
//   }
//   console.time("compare Group");
//   const result = Util.isEqual(extractPropsFromVs(prevProps), extractPropsFromVs(nextProps));
//   console.timeEnd("compare Group");
//   return result;
// });

export default GroupSlice;
