import React from "react";
import { Dimensions, View } from "react-native";
import PropTypes from "prop-types";
import Group from "../group/index";
import { getTheme } from "../../styles/themes";
import { StatusBar } from 'react-native';
import { KeyboardAwareScrollView } from "react-native-keyboard-aware-scrollview";
import { deviceHeight } from "../../helpers/util";


const CevTDL = ({ vs, dispatch, timeZoneOffset, isRTL, themeName, customStyle, isLoading ,pageNumber}) => {
  const { groups } = vs.tdl;
  const theme = getTheme(themeName)
  console.log("gjfgfjgfgjf", isLoading)
  return (

    groups.map((group, index) => (


      <Group
        key={group.id}
        vs={vs}
        path=""
        tdlPath={`groups-${index}`}
        dispatch={dispatch}
        timeZoneOffset={timeZoneOffset}
        isRTL={isRTL}
        theme={theme}
        customStyle={customStyle}
        isLoading={isLoading}
        pageNumber={pageNumber}
      />


    )));
};

CevTDL.propTypes = {
  vs: PropTypes.objectOf(PropTypes.any).isRequired,
  dispatch: PropTypes.func.isRequired,
  timeZoneOffset: PropTypes.number.isRequired,
  isRTL: PropTypes.bool.isRequired,
  themeName: PropTypes.string.isRequired,
  customStyle: PropTypes.objectOf(PropTypes.any)
};

export default CevTDL;
