import React from "react";
import PropTypes from "prop-types";
import * as Util from "../../../helpers/util";
import HTMLValue from "../../htmlValue";

const HelpContent = ({ help }) => {
  if (!help) return "";
  if (Util.isHTML(help)) {
    return <HTMLValue value={help} />;
  }
  if (help.includes("URL:")) {
    return (
      <iframe
        title={`${help}_help_iframe`}
        frameBorder="0"
        style={{ width: theme.tdlIframe.width , height : theme.tdlIframe.height }}
        src={`${process.env.REACT_APP_BASE_URL}${help.split("URL:")[1]}`}
      />
    );
  }
  return help;
};

HelpContent.propTypes = {
  help: PropTypes.string.isRequired,
};

export default HelpContent;
