import React, {useState} from "react";
import PropTypes from "prop-types";
import {ActivityIndicator , Button} from '@ant-design/react-native';
import { Container, Header, Content, Form, Item, Input } from 'native-base'
// import { Form, Input, Button, Row, Image, Spin } from "antd";
// import { UserOutlined, LockOutlined } from "@ant-design/icons";
// import LogoFull from "./assets/elixir_logo_full.png";

const LoginScreen = ({
  loginHandler,
  usernameWarningMessage,
  passwordWarningMessage,
  usernameLabel,
  passwordLabel,
  loginLabel,
  isLoading,
}) => {
  const [un, setUn] = useState("")
  const [pass, setPass] = useState("")
  const formHandler = async (values) => {
    const { username, password } = values;
    
    loginHandler(`"${username}""`, `"${password}"`);
  };
  return (
  <>
    <ActivityIndicator
      animating={isLoading} 
      toast
      size="large"
      text="Loading..." 
    />
    
    <Container>
        <Header />
        <Content>
        <Form onFinish={formHandler} style={{ borderColor: "black", borderWidth: 2 }}>
          {/* <Image src={LogoFull} /> */}
          <Item name="username" rules={[{ required: true, message: usernameWarningMessage }]}>
            <Input
            //  prefix={<UserOutlined className="site-form-item-icon"/>}
              placeholder={usernameLabel} 
              value={un}
              onChange={value => {
                setUn(value);
              }}

            />
          </Item>

          <Item name="password" rules={[{ required: true, message: passwordWarningMessage }]}>
            <Input
              // prefix={<LockOutlined className="site-form-item-icon" />}
              placeholder={passwordLabel}
              value={pass}
              onChange={value => {
                setPass(value);
              }}
            />
          </Item>

          <Item>
            <Button type="primary" htmlType="submit" onPress={formHandler}>
              {loginLabel}
            </Button>
          </Item>
        </Form>
        
        </Content>
    </Container>
  </>
    
  );
};

LoginScreen.propTypes = {
  loginHandler: PropTypes.func.isRequired,
  usernameWarningMessage: PropTypes.string.isRequired,
  passwordWarningMessage: PropTypes.string.isRequired,
  usernameLabel: PropTypes.string.isRequired,
  passwordLabel: PropTypes.string.isRequired,
  loginLabel: PropTypes.string.isRequired,
  isLoading: PropTypes.bool,
};

LoginScreen.defaultProps = {
  isLoading : false
}

export default LoginScreen;
