import { color } from "react-native-reanimated";

const THEMES = {
  default: {
    primary_color: "#3F51B5",
    secondary_color: "white",
    labels: "black",
    background: "black",
    buttonText: "white",
    borderColor: "#5d73e3",
    faddedBackground: "#ebebeb",
  },
};

const registerTheme = (name, themeObject) => {
  THEMES[name] = themeObject;
};

const registerThemeAdvanced = (name, colors, header, headerTitle, headerIcon, headerModal, footerButton,
  pagination, customTheme) => {
  let newtheme = { ...colors, header, headerTitle, headerIcon, headerModal, footerButton, pagination }
  newtheme = { ...newtheme, customTheme }

  THEMES[name] = newtheme

}
const getTheme = (themeName) => {
  //console.log(themeName);
  const STYLES = {
    colors: THEMES[themeName],
    header: {
      backgroundColor: THEMES[themeName].primary_color,
      borderBottom: "2px solid rgb(221, 221, 221)",
      ...THEMES[themeName].header,

    },

    headerTitle: {
      color: THEMES[themeName].primary_color,
      ...THEMES[themeName].headerTitle,

    },
    headerIcon: {
      backgroundColor: THEMES[themeName].primary_color,
      color: THEMES[themeName].secondary_color,
      borderColor: THEMES[themeName].primary_color,
      ...THEMES[themeName].headerIcon,
    },
    headerModal: {

      backgroundColor: THEMES[themeName].primary_color,
      ...THEMES[themeName].header
    },
    headerModalTitle: {
      color: THEMES[themeName].primary_color,
      ...THEMES[themeName].headerTitle,
    },
    footerButton: {
      backgroundColor: THEMES[themeName].primary_color,
      color: THEMES[themeName].secondary_color,
      flex: 1
    },
    pagination: {
      ...THEMES[themeName].pagination
    },
    groupsContainerComponent: {
      display: "flex",
      flexDirection: "column",
      padding: 10,
      width: "100%",
      flex: 1
    },
    keyTextArea: {
      flex: 1,
      justifyContent: 'center',
      // marginLeft: -40,
      // marginRight: 5,

    },
    keyInputItem: {
      justifyContent: 'center',
      color: "black",
      backgroundColor: 'red',
      paddingLeft: 3,
      elevation: 1,
      borderRadius: 2,
      marginLeft: -15,
      marginRight: 10,
      flex: 1,
      borderWidth: 0.4,

    },
    keyView: {
      flex: 1,
      justifyContent: 'center',
      flexDirection: 'row'
    },
    keyIcon: {
      top: -30,
      borderBottomColor: "transparent",
      alignSelf: 'flex-start'
    },
    keyValue: {
      marginLeft: -40,
      marginRight: -5,
    },
    keyMultiSelect: {
      marginLeft: -15,
      marginRight: -5
    },
    keyDropdownMenu: {
      marginLeft: -40,
      marginRight: -5,
      borderColor: 'red',
      borderRadius: 20
    },
    keyLabel: {
      flex: 1,
    },
    keyReadmore: {
      fontSize: 18,
      textAlign: 'center',
      borderBottomWidth: 1.5,

    },
    keyText: {
      fontSize: 15,
      textAlign: "auto",
      fontFamily: "AlmaraiLight",
    },
    keyListContainer: {
      elevation: 1,
      padding: 5,
      borderWidth: 0.2,
      borderRadius: 2,
      marginLeft: -15,
      marginRight: 5,
      flex: 1,
      paddingVertical: 5,
    },
    keyRowList: {
      alignContent: 'center',
      justifyContent: 'center',
      elevation: 1,
      borderWidth: 1,
      borderRadius: 5,
    },
    keyDate: {
      flex: 3,
      textAlign: 'center',
      justifyContent: 'center'
    },
    keyButton: {
      flex: 2,
    },
    keyDateTimePicker: {
      marginLeft: -40,
      marginRight: -5,
    },
    keyBoolean: {
      backgroundColor: "transparent",
      borderBottomWidth: 1.5,
    },
    keyRowList: {
      flex: 1,
      alignContent: 'center',
      justifyContent: 'center',
      borderWidth: 0.2,
    },
    keyItemsContainer: {
      padding: 5
    },
    tdlIframe: {
      width: "100%",
      height: '70vh',
      padding: 20
    },
    tdlContainer: {
      alignItems: "center",
      backgroundColor: "#ede3f2",
      padding: 100,
    },
    tdlModal: {
      flex: 1,
      alignItems: "center",
      backgroundColor: "#f7021a",
      padding: 100,
    },
    tdlText: {
      color: "#3f2949",
      marginTop: 10,
    },
    tdlScrollView: {
      flexGrow: 1,
    },
    tdlIcon: {
      padding: 0,
      margin: 0,
    },
    tdlHStack: {
      justifyContent: "space-between",
      alignSelf: "auto"
    },
    tdlHStackSMS: {
      justifyContent: "space-between",
      alignSelf: "auto",
      padding: 10
    },
    tdlViewActions: {
      flexDirection: "row",
      justifyContent: "space-between",
      alignItems: "center",
    },
    tdlView: {
      flex: 1,
      flexDirection: "row",
      justifyContent: "space-between",
      alignItems: "center",
    },
    tdlViewSMSMobile: {
      flex: 1
    },
    tdlViewSMSWEB: {
      flex: 1,
      marginBottom: 20
    },
    tdlSMSContainer: {
      display: "flex",
      flexDirection: "column",
      width: "100%",
      borderTop: "2px solid #c4cbd3",
      borderRadius: 10,
      padding: 5
    },
    tdlSMSIconContainer: {
      width: "100%",
      padding: 5,
      alignItems: "flex-start"
    },
    tdlSMSIcon: {
      fontSize: 20,
      color: "#333"
    },
    tdlViewActionBottom: {
      flexDirection: "row",
    },
    tdlViewSMS: {
      flex: 2,
    },
    tdlDrawer: {
      shadowColor: "#000000",
      shadowOpacity: 0.8,
      shadowRadius: 3
    },
    tdlMain: {
      paddingLeft: 3
    },
    tdlPressed: {
      padding: 4
    },
    tdlWebView: {
      justifyContent: 'center',
      alignItems: 'center',
      flex: 1,
    },
    tdlContainer: {
      flex: 1,
    },
    ...THEMES[themeName].customTheme
  };
  //console.log(themeS[themeName])
  return STYLES;
};

export { getTheme, registerTheme, registerThemeAdvanced };
